using System;
using System.Collections;
using System.Text;
using System.IO;
using System.Windows.Forms;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Soap;

namespace ruche.nive2.aviutlPluginPorts
{
    /// <summary>
    /// ̃Cu̐ݒ̕ۑƓǂݍ݂sVOgNXB
    /// </summary>
    public class LibraryConfig
    {
        /// <summary>
        /// B̃CX^XB
        /// </summary>
        private static LibraryConfig _instance;

        /// <summary>
        /// ݒt@C̃pXB
        /// </summary>
        private string _configFilePath;

        /// <summary>
        /// ۑΏۂ̃f[^B
        /// </summary>
        private Hashtable _datas;

        /// <summary>
        /// RXgN^B
        /// </summary>
        private LibraryConfig()
        {
            // f[^
            _datas = new Hashtable();

            // ݒt@C̃pXݒ
            _configFilePath = Environment.GetFolderPath(
                Environment.SpecialFolder.LocalApplicationData);
            _configFilePath = Path.Combine(
                _configFilePath,
                @"ruche-home\" +
                typeof(LibraryConfig).Namespace + @"\" +
                typeof(LibraryConfig).Namespace + @".dll.config");
        }

        /// <summary>
        /// ÓIRXgN^B
        /// </summary>
        static LibraryConfig()
        {
            _instance = new LibraryConfig();
        }

        /// <summary>
        /// B̃CX^X擾B
        /// </summary>
        public static LibraryConfig Datas
        {
            get { return _instance; }
        }

        /// <summary>
        /// ݒۑt@C̃pX擾B
        /// </summary>
        public string ConfigFilePath
        {
            get { return _configFilePath; }
        }

        /// <summary>
        /// ݒ擾܂͐ݒ肷B
        /// </summary>
        /// <param name="key">ݒ̃L[B</param>
        /// <returns>ݒB</returns>
        public object this[object key]
        {
            get { return _datas[key]; }
            set { _datas[key] = value; }
        }

        /// <summary>
        /// w肵L[̏񂪑݂邩ۂ擾B
        /// </summary>
        /// <param name="key">L[B</param>
        /// <returns>݂ꍇ true BłȂ false B</returns>
        public bool ContainsKey(object key)
        {
            return _datas.ContainsKey(key);
        }

        /// <summary>
        /// w肵L[̏j܂B
        /// </summary>
        /// <param name="key">L[B</param>
        public void Remove(object key)
        {
            _datas.Remove(key);
        }

        /// <summary>
        /// ݒ̃[hsB
        /// </summary>
        /// <returns>
        /// [hsꂽꍇ true BłȂ false B
        /// </returns>
        public bool Load()
        {
            bool result = false;

            if (File.Exists(ConfigFilePath))
            {
                SoapFormatter formatter = new SoapFormatter();
                try
                {
                    using (FileStream fs = new FileStream(
                        ConfigFilePath, FileMode.Open, FileAccess.Read))
                    {
                        // fVACY
                        object obj = formatter.Deserialize(fs);
                        fs.Close();

                        // LXgĎ擾
                        if (!(obj is Hashtable))
                        {
                            throw new ApplicationException(
                                "ݒt@C̓esłB");
                        }
                        _datas = obj as Hashtable;

                        result = true;
                    }
                }
                catch
                {
                    result = false;
                }
            }

            return result;
        }

        /// <summary>
        /// ݒ̃Z[usB
        /// </summary>
        public void Save()
        {
            try
            {
                // fBNg݂Ȃ΍쐬
                string dirPath = Path.GetDirectoryName(ConfigFilePath);
                if (!Directory.Exists(dirPath))
                {
                    Directory.CreateDirectory(dirPath);
                }

                // VACY
                SoapFormatter formatter = new SoapFormatter();
                using (FileStream fs = new FileStream(
                    ConfigFilePath, FileMode.Create, FileAccess.Write))
                {
                    formatter.Serialize(fs, _datas);
                    fs.Close();
                }
            }
            catch (Exception ex)
            {
            #if DEBUG
                MessageBox.Show(
                    ex.Message + "\n\n" + ex.StackTrace, ex.GetType().FullName,
                    MessageBoxButtons.OK);
            #endif

                throw ex;
            }
        }
    }
}
